require("brains/taibrain")
--require("stategraphs/SGbutterfly")

local assets=
{
	Asset("ANIM", "anim/tai_build.zip"),
	Asset("ANIM", "anim/butterfly_basic.zip"),
}

local prefabs = 
{
	"taiwings",
	--"someprefab",
}

SetSharedLootTable('tai',
{
    {'taiwings',             1.00},
})

local WAKE_TO_FOLLOW_DISTANCE = 14
local SLEEP_NEAR_LEADER_DISTANCE = 7
--local OLD_DATA = TUNING.TOTAL_DAY_TIME * 2

local function ShouldWakeUp(inst)
    return DefaultWakeTest(inst) or not inst.components.follower:IsNearLeader(WAKE_TO_FOLLOW_DISTANCE)
end

local function ShouldSleep(inst)
    --print(inst, "ShouldSleep", DefaultSleepTest(inst), not inst.sg:HasStateTag("open"), inst.components.follower:IsNearLeader(SLEEP_NEAR_LEADER_DISTANCE))
    return DefaultSleepTest(inst) 
    and inst.components.follower:IsNearLeader(SLEEP_NEAR_LEADER_DISTANCE) 
    and not TheWorld.state.isfullmoon
end

local function CalcSanityAura(inst, observer)
	return TUNING.SANITYAURA_TINY
end


local function OnEntitySleep(inst)

end

local function OnSave(inst, data)
	if inst.taihappiness then
		data.taihappiness = inst.taihappiness
	end
end

local function OnLoad(inst, data)
	if data and data.taihappiness then
		inst.taihappiness = data.taihappiness
	end
end

local function TaiItemSpawnHandler(inst,doRetry)
	if doRetry then
		inst.components.periodicspawner.basetime = ZACK_CHARLIE_CHARACTER_MOD.TAI_RETRY_GIFT_BASETIME
		inst.components.periodicspawner.randtime = ZACK_CHARLIE_CHARACTER_MOD.TAI_RETRY_GIFT_RANDTIME
		inst.components.periodicspawner:Stop()
		inst.components.periodicspawner:Start()	
	else
		inst.components.periodicspawner.basetime = ZACK_CHARLIE_CHARACTER_MOD.TAI_GIFT_BASETIME
		inst.components.periodicspawner.randtime = ZACK_CHARLIE_CHARACTER_MOD.TAI_GIFT_RANDTIME
		inst.components.periodicspawner:Stop()
		inst.components.periodicspawner:Start()
	end
end

local function OnSpawnFuel(inst, fuel)
	if inst.taihappiness then 
		if fuel and fuel.prefab ~= "butter" and inst.taihappiness and inst.taihappiness >= ZACK_CHARLIE_CHARACTER_MOD.TAI_HAPPY then
			inst.sg:GoToState("producebutter", fuel)
			TaiItemSpawnHandler(inst,false)
--			print("Here comes the flowa")
			inst.taihappiness = inst.taihappiness - ZACK_CHARLIE_CHARACTER_MOD.TAI_HAPPY_FLOWER
		elseif fuel and fuel.prefab == "butter" and inst.taihappiness >= (ZACK_CHARLIE_CHARACTER_MOD.TAI_HAPPY_BUTTER + ZACK_CHARLIE_CHARACTER_MOD.TAI_HAPPY) then
			inst.sg:GoToState("producebutter", fuel)
--			print("Here comes the butta")
			inst.taihappiness = inst.taihappiness - ZACK_CHARLIE_CHARACTER_MOD.TAI_HAPPY_BUTTER
			if inst.taihappiness >= ZACK_CHARLIE_CHARACTER_MOD.TAI_HAPPY_BUTTER then
				inst.components.periodicspawner.prefab = "butter"
			else
				inst.components.periodicspawner.prefab = "flower"								
			end
			TaiItemSpawnHandler(inst,false)
		else
--			print("Tai: Can't make anything yet")
			TaiItemSpawnHandler(inst,true)
			fuel:Remove()
		end
	else
--		print("Tai: I don't have any happiness yet")
		TaiItemSpawnHandler(inst,true)
		fuel:Remove()
	end
end

local function OnStopFollowing(inst)
    --print("glommer - OnStopFollowing")
--    inst:RemoveTag("companion")
--	print("Time to find my friend!")
	if inst._playerlink then
		inst:DoTaskInTime(3,function(inst) if inst._playerlink then inst:LinkToPlayer(inst._playerlink) end end)
	end
end

local function OnStartFollowing(inst)

end

local function linktoplayer(inst, player)
--    inst.components.lootdropper:SetLoot(LOOT)
    inst.persists = false
    inst._playerlink = player
    player.taifriend = inst
	player.components.leader:AddFollower(inst, true)
--[[    for k, v in pairs(player.abigail_flowers) do
        k:Refresh()
    end--]]
--    player:ListenForEvent("onremove", unlink, inst)
end

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddDynamicShadow()
	inst.entity:AddNetwork()

    inst.Transform:SetTwoFaced()

    MakeCharacterPhysics(inst, 1, .25)
    inst.Physics:SetCollisionGroup(COLLISION.FLYERS)
    inst.Physics:ClearCollisionMask()
    inst.Physics:CollidesWith(COLLISION.WORLD)

-- 	MakeGhostPhysics(inst, 1, .5)

-- 	local minimap = inst.entity:AddMiniMapEntity()
--	minimap:SetIcon("butterfly.png")
--	minimap:SetPriority(5)

    inst.AnimState:SetBuild("butterfly_basic")
    inst.AnimState:SetBank("butterfly")
    inst.AnimState:PlayAnimation("idle",true)
    inst.AnimState:SetRayTestOnBB(true)

    inst.DynamicShadow:SetSize(.8, .5)

--	inst:AddTag("glommer")
	inst:AddTag("flying")
--    inst:AddTag("cattoyairborne")

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.entity:SetPristine()

	inst:AddComponent("inspectable")
	
	inst:AddComponent("follower")
	inst:ListenForEvent("stopfollowing", OnStopFollowing)
    inst:ListenForEvent("startfollowing", OnStartFollowing)

	inst:AddComponent("health")
	inst:AddComponent("combat")
	inst:AddComponent("knownlocations")
	inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('tai') 

--[[	inst:AddComponent("sleeper")
    inst.components.sleeper:SetResistance(3)
    inst.components.sleeper.testperiod = GetRandomWithVariance(6, 2)
    inst.components.sleeper:SetSleepTest(ShouldSleep)
    inst.components.sleeper:SetWakeTest(ShouldWakeUp)--]] --See if this is breaking Tai on clients

    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aurafn = CalcSanityAura

	inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed = 6
    inst.components.locomotor:EnableGroundSpeedMultiplier(false)
    inst.components.locomotor:SetTriggersCreep(false)

	
    inst:AddComponent("periodicspawner")
    inst.components.periodicspawner:SetOnSpawnFn(OnSpawnFuel)
    inst.components.periodicspawner.prefab = "flower"
	inst.components.periodicspawner:SetMinimumSpacing(ZACK_CHARLIE_CHARACTER_MOD.TAI_GIFT_MINSPACING)
    inst.components.periodicspawner.basetime = ZACK_CHARLIE_CHARACTER_MOD.TAI_GIFT_BASETIME
    inst.components.periodicspawner.randtime = ZACK_CHARLIE_CHARACTER_MOD.TAI_GIFT_RANDTIME
    inst.components.periodicspawner:Start()
	
    local brain = require("brains/taibrain")
    inst:SetBrain(brain)
    inst:SetStateGraph("SGtai_butter")
--	inst.sg:GoToState("idle")
--	inst.AnimState:PlayAnimation("idle", true)

--    MakeMediumFreezableCharacter(inst, "glommer_body")

    inst.OnSave = OnSave
    inst.OnLoad = OnLoad
    inst.OnEntitySleep = OnEntitySleep

	
	MakeHauntablePanic(inst)

	--Tai Exclusive Stuff
   	inst:AddTag("companion")
    inst.LinkToPlayer = linktoplayer

	return inst
end


return Prefab("common/creatures/tai", fn, assets, prefabs)
